Gecode::Int::NValues::BoolBase< VY > Class Template Reference
Other available functionality » Integer propagators

Number of values propagator for Boolean views base class. More...

`#include <nvalues.hh>`

## Public Member Functions

virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Give advice to propagator.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low unary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| BoolBase (Home home, int status, ViewArray< BoolView > &x, VY y)
| Constructor for posting.
| BoolBase (Space &home, BoolBase< VY > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

int | status
| Status information about the views.
Council< ViewAdvisor< BoolView > > | c
| The advisor council.
VY | y
| The view for counting the number of values.

## Static Protected Attributes

static const int | VS_ZERO = 1 << 0
| View status: a zero has already been encountered.
static const int | VS_ONE = 1 << 1
| View status: a one has already been encountered.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class VY>
class Gecode::Int::NValues::BoolBase< VY >

Number of values propagator for Boolean views base class.

Requires

#include <gecode/int/nvalues.hh>
nvalues.hh

Definition at line 293 of file nvalues.hh.

## Constructor & Destructor Documentation

## BoolBase() [1/2]

template<class VY>

Gecode::Int::NValues::BoolBase< VY >::BoolBase | ( | Home | home,
|  | int | status,
|  | ViewArray< BoolView > & | x,
|  | VY | y )

inline protected

Constructor for posting.

Definition at line 38 of file bool-base.hpp.

## BoolBase() [2/2]

template<class VY>

Gecode::Int::NValues::BoolBase< VY >::BoolBase | ( | Space & | home,
|  | BoolBase< VY > & | p )

inline protected

Constructor for cloning p.

Definition at line 50 of file bool-base.hpp.

## Member Function Documentation

## advise()

template<class VY>

ExecStatus Gecode::Int::NValues::BoolBase< VY >::advise | ( | Space & | home,
|  | Advisor & | a,
|  | const Delta & | d )

virtual

Give advice to propagator.

Reimplemented from Gecode::Propagator.

Definition at line 70 of file bool-base.hpp.

## cost()

template<class VY>

PropCost Gecode::Int::NValues::BoolBase< VY >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low unary).

Implements Gecode::Propagator.

Definition at line 58 of file bool-base.hpp.

## reschedule()

template<class VY>

void Gecode::Int::NValues::BoolBase< VY >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 64 of file bool-base.hpp.

## dispose()

template<class VY>

size_t Gecode::Int::NValues::BoolBase< VY >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 91 of file bool-base.hpp.

## Member Data Documentation

## VS_ZERO

template<class VY>

const int Gecode::Int::NValues::BoolBase< VY >::VS_ZERO = 1 << 0

static protected

View status: a zero has already been encountered.

Definition at line 296 of file nvalues.hh.

## VS_ONE

template<class VY>

const int Gecode::Int::NValues::BoolBase< VY >::VS_ONE = 1 << 1

static protected

View status: a one has already been encountered.

Definition at line 298 of file nvalues.hh.

## status

template<class VY>

int Gecode::Int::NValues::BoolBase< VY >::status

protected

Status information about the views.

Definition at line 300 of file nvalues.hh.

## c

template<class VY>

Council<ViewAdvisor<BoolView> > Gecode::Int::NValues::BoolBase< VY >::c

protected

The advisor council.

Definition at line 302 of file nvalues.hh.

## y

template<class VY>

VY Gecode::Int::NValues::BoolBase< VY >::y

protected

The view for counting the number of values.

Definition at line 304 of file nvalues.hh.

The documentation for this class was generated from the following files:

- gecode/int/nvalues.hh
- gecode/int/nvalues/bool-base.hpp